# $Id: ModKarma.pm,v 1.3 2008/04/07 11:48:02 uhtu Exp $
# Copyright (c) 2003-2004 Robert Hagemann <bobzilla@gothictech.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModKarma;

@ModKarma::ISA = qw(OmniMod);

use strict;

my $on = 1;

my $karmaTable = "KARMATABLE";

my @yums = (
   "yum", 
   "thanks!", 
   ":-)",
   "nom nom nom",
   "you gived me a karma, but i eated it",
);

sub help {
  return if ! $on;

  if ( defined wantarray ) { # do we have help?
    return 1;
  }

  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

	$irc->notice( $nick, "[karma <nick>] check karma of nick" );
	$irc->notice( $nick, "[<nick>++] increase karma of nick" );
	$irc->notice( $nick, "[<nick>--] decrease karma of nick" );
}

sub name() {
  my $this = shift;
  return "karma";
}

sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;
  my $event = shift;

  return if ! $on;

  my $output = &checkAnyMessage( $irc, $message, $channel );
	&ModChatLog::saveMessage('omnicron', $output, $channel )
    if defined $output and $output !~ /^\s*$/si;
}

sub handlePrivateMessage {
  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;
  my $event = shift;

  return if ! $on;

  &checkAnyMessage( $irc, $message, $nick );
}

sub checkAnyMessage {
  my $irc = shift;
  my $message = shift;
  my $sendTo = shift;

  my $output;

  if ( $message =~ /^\s*(\S+)\+\+/si ) {
    my $nick = $1;
    if ( $sendTo !~ /\x23/ ) { # only count karma sent to channels
      $irc->privmsg( $sendTo, 
                     "karma can only be portioned out by the cosmos" );
    } else {
      &getKarma( $nick, 1 );
    }
  }
  elsif ( $message =~ /^\s*(\S+)\-\-/si ) {
    my $nick = $1;
    if ( $sendTo !~ /\x23/ ) { # only count karma sent to channels
      $irc->privmsg( $sendTo, 
                     "karma can only be portioned out by the cosmos" );
    } else {
      &getKarma( $nick, -1 );
    }
  }
  elsif ( $message =~ /^\s*karma\s+(\S+)\s*$/si ) {
    my $nick = $1;
    my $karma = &getKarma( $nick );
    if ( defined $karma and $karma != 0 ) {
      $output = "$nick has karma " . $karma;
    }
    else {
      $output = "$nick has no karma";
    }
    $irc->privmsg( $sendTo, $output );
  }
  elsif ( $message =~ /\s*botsnack$/si ) {
    &getKarma( 'omnicron', 1 );
    my $yum = $yums[rand(@yums)];
    $irc->privmsg( $sendTo, $yum ); 
  }

  return $output;
}

sub getKarma {
  my $name = shift;
  my $add = shift;
  $add = 0 if ! defined $add;

	my $karma = OmniHash::getHash( $karmaTable );
  $$karma{ $name } = 0 if ! defined $$karma{ $name };
  $$karma{ $name } += $add;
  my $retval = $$karma{ $name };
	OmniHash::closeAllHashes();

  return $retval;
}

1;
